DEFINT A-Z
DECLARE SUB Precalc ()
DECLARE SUB VscrollUp ()
DECLARE SUB SetVoffset (y%)
DECLARE SUB ShowVirtLine (j%)
DECLARE SUB LoadRAW (filename$)
DECLARE SUB VirtPset (x%, r%, g%, b%)
DECLARE SUB XPset (x%, y%, c%)
DECLARE SUB Set320x400 ()
DECLARE SUB SetPalette ()
DECLARE SUB SetGreyScale ()

'-----------------------------------------------------------
' 13BIT.BAS - 2 pixel Mode-X pseudo-hicolor mode
'     Emulates 320x200x2 pages @13bit color (~Hicolor)
'        using 320x400x2 pages @6bit color depth (VGA Mode-X)
' * Idea and initial implementation by logiclrd.
' * Mode-X scanline method and buffering by Toshi
' * AMGPCD23.RAW saved in Paint Shop Pro as a 320x400
'   resolution RGB-ordered 16 million color .RAW file.
'----------------------------------------------------------
CONST maxy = 399
CONST maxx = 319
xmax = maxx + 1: ymax = maxy + 1

DIM SHARED times15%(14)
DIM SHARED virtgreen%(xmax)
DIM SHARED virtrb%(xmax)

Set320x400
SetPalette
SetGreyScale

SetVoffset maxy
LoadRAW "AMGPCD23.RAW"
SetPalette

VscrollUp
SLEEP 5

SCREEN 0: WIDTH 80, 25

SUB LoadRAW (filename$)
Precalc
'loads a 320 x (maxy+1) 16-bit color RGB-encoded .RAW file
'and prebiases the color components to 4-5-4 mode.
'assumes that we're already in modex when updating progress bar
ff% = FREEFILE
OPEN filename$ FOR BINARY AS #ff%
IF LOF(1) = 0 THEN
    SCREEN 0: WIDTH 80: CLS
    PRINT "**"; filename$; " doesn't exist.**"
    CLOSE : KILL filename$: END
END IF

buffer$ = STRING$((maxx + 1) * 3, 64)
DEF SEG = &HA000
FOR j% = 0 TO maxy
 GET #ff%, , buffer$
 s% = 0
 FOR i% = 0 TO maxx
  r% = (ASC(MID$(buffer$, s% + 1, 1)) * 7) \ 128
  g% = (ASC(MID$(buffer$, s% + 2, 1)) * 15) \ 128
  b% = (ASC(MID$(buffer$, s% + 3, 1)) * 7) \ 128
  s% = s% + 3
  VirtPset i%, r%, g%, b%
 NEXT i%
 ShowVirtLine j%
NEXT j%
CLOSE #ff%
END SUB

SUB Precalc
FOR i% = 1 TO 14
 times15%(i%) = times15%(i% - 1) + 15
NEXT i%
END SUB

SUB Set320x400
'sets up our 320x400 @256 color unchained Mode-X resolution
 DEF SEG = &HA000
 SCREEN 13
 OUT &H3D4, 9: OUT &H3D5, &H40
 OUT &H3D4, 20: OUT &H3D5, 0:
 OUT &H3D4, 23: OUT &H3D5, &HE3
 OUT &H3C4, 4: OUT &H3C5, &H6
 CLS
 OUT &H3C4, 2: OUT &H3C5, 1

END SUB

SUB SetGreyScale
'converts the current palette into greyscale

DIM pal%(768)
i% = 0
'save current palette into pal%()
FOR c% = 0 TO 255
    OUT &H3C7, c%
    pal%(i%) = INP(&H3C9): i% = i% + 1
    pal%(i%) = INP(&H3C9): i% = i% + 1
    pal%(i%) = INP(&H3C9): i% = i% + 1
NEXT c%
i% = 0
'changes to greyscale
FOR c% = 0 TO 255
        OUT &H3C8, c%
        e% = (pal%(i%) + pal%(i% + 1) + pal%(i% + 2)) \ 3
        OUT &H3C9, e%
        OUT &H3C9, e%
        OUT &H3C9, e%
        i% = i% + 3
NEXT c%
END SUB

SUB SetPalette
'set up the palette to do fake-hicolor

OUT &H3C8, 0
'red to blue gradients again
FOR i% = 0 TO 14
 FOR j% = 0 TO 14
  OUT &H3C9, (i% * 63) \ 14
  OUT &H3C9, 0
  OUT &H3C9, (j% * 63) \ 14
 NEXT j%
NEXT i%

'dark green->bright green->whitish green
'this palette results in brighter whites
FOR i% = 0 TO 20
 OUT &H3C9, 0
 OUT &H3C9, (i% * 63) \ 30
 OUT &H3C9, 0
NEXT i%
FOR i% = 21 TO 30
 OUT &H3C9, (i% - 21) * 4 'extra red
 OUT &H3C9, (i% * 63) \ 30
 OUT &H3C9, (i% - 21) * 4 'extra blue
NEXT i%

END SUB

SUB SetVoffset (y%)
  offset& = y% * 80&
  OUT &H3D4, 12
  OUT &H3D5, offset& \ 256
  WAIT &H3DA, 8
  OUT &H3D4, 13
  OUT &H3D5, offset& AND 255
END SUB

SUB ShowVirtLine (j%)
' renders a virtual line to the
'  correct Mode-X double pixels
r& = j% * 160&

o& = r& 'Plane 0
OUT &H3C4, 2
OUT &H3C5, 1
FOR i% = 0 TO maxx STEP 4
  POKE o&, virtgreen%(i%)
  POKE o& + 80, virtrb%(i%)
  o& = o& + 1
NEXT

o& = r&
OUT &H3C4, 2
OUT &H3C5, 2 'select Plane 1
FOR i% = 1 TO maxx STEP 4
  POKE o&, virtgreen%(i%)
  POKE o& + 80, virtrb%(i%)
  o& = o& + 1
NEXT

o& = r&
OUT &H3C4, 2
OUT &H3C5, 4 'select Plane 2
FOR i% = 2 TO maxx STEP 4
  POKE o&, virtgreen%(i%)
  POKE o& + 80, virtrb%(i%)
  o& = o& + 1
NEXT

o& = r&
OUT &H3C4, 2
OUT &H3C5, 8  'select Plane 3
FOR i% = 3 TO maxx STEP 4
  POKE o&, virtgreen%(i%)
  POKE o& + 80, virtrb%(i%)
  o& = o& + 1
NEXT
END SUB

SUB VirtPset (x%, r%, g%, b%)
' plots a pixel into a virtual line on the screen
virtgreen%(x%) = g% + 225
virtrb%(x%) = times15%(r%) + b%
END SUB

SUB VscrollUp
'smoothly scroll down
offset& = maxy * 80&
WHILE offset& > 0
  OUT &H3D4, 12: OUT &H3D5, offset& \ 256
  OUT &H3D4, 13: OUT &H3D5, offset& AND 255
  WAIT &H3DA, 8
  WAIT &H3DA, 8, 8
  offset& = offset& - 80
WEND
END SUB

SUB XPset (x%, y%, c%)
'normal mode-x point plotting procedure
'makes mode-x memory accesses seem linear
OUT &H3C4, 2
plane% = x% AND 3
SELECT CASE plane%
   CASE 0: OUT &H3C5, 1
   CASE 1: OUT &H3C5, 2
   CASE 2: OUT &H3C5, 4
   CASE 3: OUT &H3C5, 8
END SELECT
DEF SEG = &HA000
POKE y% * 80& + x% \ 4, c%
END SUB

